/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for output of voltage between 0 and 5V
	/// </summary>
	public class BrickletAnalogOut : Device 
	{

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_VOLTAGE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_VOLTAGE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_MODE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_MODE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletAnalogOut.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletAnalogOut.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletAnalogOut(string uid, IPConnection ipcon) : base(uid, ipcon) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;


			responseExpected[FUNCTION_SET_VOLTAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MODE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MODE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
		///  Calling this function will set the mode to 0 (see <see cref="Tinkerforge.BrickletAnalogOut.SetMode"/>).
		///  
		///  The default value is 0 (with mode 1).
		/// </summary>
		public void SetVoltage(int voltage)
		{
			byte[] data_ = MakePacketHeader(10, FUNCTION_SET_VOLTAGE);
			LEConverter.To((short)voltage, 8, data_);

			if(responseExpected[FUNCTION_SET_VOLTAGE] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_VOLTAGE] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_VOLTAGE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the voltage as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		/// </summary>
		public int GetVoltage()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_VOLTAGE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_VOLTAGE, out response);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the mode of the analog value. Possible modes:
		///  
		///  * 0: Normal Mode (Analog value as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/> is applied
		///  * 1: 1k Ohm resistor to ground
		///  * 2: 100k Ohm resistor to ground
		///  * 3: 500k Ohm resistor to ground
		///  
		///  Setting the mode to 0 will result in an output voltage of 0. You can jump
		///  to a higher output voltage directly by calling <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		///  
		///  The default mode is 1.
		/// </summary>
		public void SetMode(byte mode)
		{
			byte[] data_ = MakePacketHeader(9, FUNCTION_SET_MODE);
			LEConverter.To((byte)mode, 8, data_);

			if(responseExpected[FUNCTION_SET_MODE] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_MODE] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_MODE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the mode as set by <see cref="Tinkerforge.BrickletAnalogOut.SetMode"/>.
		/// </summary>
		public byte GetMode()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_MODE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_MODE, out response);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers are:
		///  
		///  <code>
		///   "Device Identifier", "Device"
		///  
		///   "11", "Brick DC"
		///   "12", "Brick Debug"
		///   "13", "Brick Master 2.0"
		///   "14", "Brick Servo"
		///   "15", "Brick Stepper"
		///   "16", "Brick IMU"
		///   "", ""
		///   "21", "Bricklet Ambient Light"
		///   "22", "Bricklet Breakout"
		///   "23", "Bricklet Current12"
		///   "24", "Bricklet Current25"
		///   "25", "Bricklet Distance IR"
		///   "26", "Bricklet Dual Relay"
		///   "27", "Bricklet Humidity"
		///   "28", "Bricklet IO-16"
		///   "29", "Bricklet IO-4"
		///   "210", "Bricklet Joystick"
		///   "211", "Bricklet LCD 16x2"
		///   "212", "Bricklet LCD 20x4"
		///   "213", "Bricklet Linear Poti"
		///   "214", "Bricklet Piezo Buzzer"
		///   "215", "Bricklet Rotary Poti"
		///   "216", "Bricklet Temperature"
		///   "217", "Bricklet Temperature IR"
		///   "218", "Bricklet Voltage"
		///   "219", "Bricklet Analog In"
		///   "220", "Bricklet Analog Out"
		///   "221", "Bricklet Barometer"
		///   "222", "Bricklet GPS"
		///   "223", "Bricklet Industrial Digital In 4"
		///   "224", "Bricklet Industrial Digital Out 4"
		///   "225", "Bricklet Industrial Quad Relay"
		///   "226", "Bricklet PTC"
		///   "227", "Bricklet Voltage/Current"
		///  </code>
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}
	}
}