/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for sensing Temperature
	/// </summary>
	public class BrickletTemperature : Device 
	{

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_TEMPERATURE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_TEMPERATURE = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_TEMPERATURE_REACHED = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletTemperature.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletTemperature.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackPeriod"/>. The parameter is the temperature
		///  of the sensor.
		///  
		///  <see cref="Tinkerforge.BrickletTemperature.Temperature"/> is only triggered if the temperature has changed since the
		///  last triggering.
		/// </summary>
		public event TemperatureEventHandler Temperature;
		public delegate void TemperatureEventHandler(object sender, short temperature);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackThreshold"/> is reached.
		///  The parameter is the temperature of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletTemperature.SetDebouncePeriod"/>.
		/// </summary>
		public event TemperatureReachedEventHandler TemperatureReached;
		public delegate void TemperatureReachedEventHandler(object sender, short temperature);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletTemperature(string uid, IPConnection ipcon) : base(uid, ipcon) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_TEMPERATURE] = new MessageCallback(OnTemperature);
			messageCallbacks[CALLBACK_TEMPERATURE_REACHED] = new MessageCallback(OnTemperatureReached);

			responseExpected[FUNCTION_GET_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_TEMPERATURE_REACHED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Returns the temperature of the sensor. The value
		///  has a range of -2500 to 8500 and is given in °C/100,
		///  e.g. a value of 4223 means that a temperature of 42.23 °C is measured.
		///  
		///  If you want to get the temperature periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickletTemperature.Temperature"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public short GetTemperature()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_TEMPERATURE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_TEMPERATURE, out response);

			return LEConverter.ShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletTemperature.Temperature"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletTemperature.Temperature"/> is only triggered if the temperature has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetTemperatureCallbackPeriod(long period)
		{
			byte[] data_ = MakePacketHeader(12, FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, data_);

			if(responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackPeriod"/>.
		/// </summary>
		public long GetTemperatureCallbackPeriod()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletTemperature.TemperatureReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetTemperatureCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = MakePacketHeader(13, FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, data_);
			LEConverter.To((short)min, 9, data_);
			LEConverter.To((short)max, 11, data_);

			if(responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackThreshold"/>.
		/// </summary>
		public void GetTemperatureCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.ShortFrom(9, response);
			max = LEConverter.ShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callback
		///  
		///   <see cref="Tinkerforge.BrickletTemperature.TemperatureReached"/>
		///  
		///  is triggered, if the threshold
		///  
		///   <see cref="Tinkerforge.BrickletTemperature.SetTemperatureCallbackThreshold"/>
		///  
		///  keeps being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			byte[] data_ = MakePacketHeader(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, data_);

			if(responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_DEBOUNCE_PERIOD, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletTemperature.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers are:
		///  
		///  <code>
		///   "Device Identifier", "Device"
		///  
		///   "11", "Brick DC"
		///   "12", "Brick Debug"
		///   "13", "Brick Master 2.0"
		///   "14", "Brick Servo"
		///   "15", "Brick Stepper"
		///   "16", "Brick IMU"
		///   "", ""
		///   "21", "Bricklet Ambient Light"
		///   "22", "Bricklet Breakout"
		///   "23", "Bricklet Current12"
		///   "24", "Bricklet Current25"
		///   "25", "Bricklet Distance IR"
		///   "26", "Bricklet Dual Relay"
		///   "27", "Bricklet Humidity"
		///   "28", "Bricklet IO-16"
		///   "29", "Bricklet IO-4"
		///   "210", "Bricklet Joystick"
		///   "211", "Bricklet LCD 16x2"
		///   "212", "Bricklet LCD 20x4"
		///   "213", "Bricklet Linear Poti"
		///   "214", "Bricklet Piezo Buzzer"
		///   "215", "Bricklet Rotary Poti"
		///   "216", "Bricklet Temperature"
		///   "217", "Bricklet Temperature IR"
		///   "218", "Bricklet Voltage"
		///   "219", "Bricklet Analog In"
		///   "220", "Bricklet Analog Out"
		///   "221", "Bricklet Barometer"
		///   "222", "Bricklet GPS"
		///   "223", "Bricklet Industrial Digital In 4"
		///   "224", "Bricklet Industrial Digital Out 4"
		///   "225", "Bricklet Industrial Quad Relay"
		///   "226", "Bricklet PTC"
		///   "227", "Bricklet Voltage/Current"
		///  </code>
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnTemperature(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(8, data_);

			var handler = Temperature;
			if(handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnTemperatureReached(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(8, data_);

			var handler = TemperatureReached;
			if(handler != null)
			{
				handler(this, temperature);
			}
		}
	}
}